//
// ALT Enter Res Fix
// Version 1.0
// by Smokescreen
//

deactivatePackage(SmokeResFix);
package SmokeResFix {
	
  function SmokesAltEnter(%val)
  {
	if (!%val) return;
	%fs = isFullScreen();
        if (%fs)
        {
            %newRes = $pref::Video::DesktopRes;
            $pref::Video::oldresolution = $pref::Video::resolution;
        }	 
        else %newRes = $pref::Video::oldresolution;
	%newFullScreen = !%fs;
	setScreenMode( firstWord( %newRes ), getWord( %newRes, 1 ), getWord( %newRes, 2 ), %newFullScreen );
  }	

 
  function SmokesAltEnterSet()
  {
       %deskRes = getDesktopResolution();
       if ($pref::Video::DesktopRes $= "" || firstWord( $pref::Video::DesktopRes ) >= firstWord( %deskRes ) || getWord( $pref::Video::DesktopRes, 1 ) >= getWord( %deskRes, 1 ) )
       {
  	   %resList = getResolutionList( $pref::Video::displayDevice );
           %resCount = getFieldCount( %resList );
           for ( %i = 0; %i < %resCount; %i++ )
           {
              %res = getWords( getField( %resList, %i ), 0, 1 );
              if ( firstWord( %res ) < firstWord( %deskRes ) && getWord( %res, 1 ) < getWord( %deskRes, 1 ) ) $pref::Video::DesktopRes = %res;
              else %i = %resCount;
           }  
       }     
  }	
   

  function DispatchLaunchMode()
  {
    SmokesAltEnterSet();
    GlobalActionMap.bind(keyboard, "alt return", SmokesAltEnter);
    parent::DispatchLaunchMode();
  }

};
activatePackage(SmokeResFix);